"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var sketch2json = require("sketch2json");
var validateGroup_1 = require("./utilities/validateGroup");
var validateLayers_1 = require("./utilities/validateLayers");
function lintLayersForPages(pages, validatorGroups) {
    function lintLayerForPage(_a) {
        var layers = _a.layers, name = _a.name;
        return validateLayers_1.default(layers, {
            default: validatorGroups.layers || {},
            artboard: validatorGroups.artboards || {},
            group: validatorGroups.groups || {},
        }, {
            getCategory: function (className) {
                if (className === 'artboard') {
                    return 'artboards';
                }
                else if (className === 'group') {
                    return 'groups';
                }
                return 'layers';
            },
            pathPrefix: name,
        });
    }
    var lintingErrors = [];
    for (var _i = 0, pages_1 = pages; _i < pages_1.length; _i++) {
        var page = pages_1[_i];
        lintingErrors = lintingErrors.concat(lintLayerForPage(page));
    }
    return lintingErrors;
}
function lintFromJSON(sketchJSON, validatorGroups) {
    var pages = Object.values(sketchJSON.pages);
    var lintingErrors = [];
    if (validatorGroups.pages) {
        var pagesErrors = validateGroup_1.default(pages, {
            getCategory: function () { return 'pages'; },
            getValidators: function () { return validatorGroups.pages; },
            getPath: function (_a) {
                var name = _a.name;
                return name;
            },
        });
        lintingErrors = lintingErrors.concat(pagesErrors);
    }
    var singleItemCategories = ['meta', 'document'];
    var _loop_1 = function (category) {
        var data = sketchJSON[category];
        var validators = validatorGroups[category];
        if (validators) {
            var categoryErrors = validateGroup_1.validateItem(data, validators, {
                getPath: function () { return category; },
                getCategory: function () { return category; },
            });
            lintingErrors = lintingErrors.concat(categoryErrors);
        }
    };
    for (var _i = 0, singleItemCategories_1 = singleItemCategories; _i < singleItemCategories_1.length; _i++) {
        var category = singleItemCategories_1[_i];
        _loop_1(category);
    }
    return lintingErrors.concat(lintLayersForPages(pages, validatorGroups));
}
exports.lintFromJSON = lintFromJSON;
function sketchlint(sketchData, validatorGroups) {
    return __awaiter(this, void 0, void 0, function () {
        var sketchJSON;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, sketch2json(sketchData)];
                case 1:
                    sketchJSON = _a.sent();
                    return [2, lintFromJSON(sketchJSON, validatorGroups)];
            }
        });
    });
}
exports.default = sketchlint;
//# sourceMappingURL=sketchlint.js.map