interface DynamicBase {
    [key: string]: any;
}
export declare type Layer = DynamicBase;
export declare type Meta = DynamicBase;
export declare type Document = DynamicBase;
export interface Page extends DynamicBase {
    name: string;
    layers: Layer[];
}
export declare type ErrorType = 'error' | 'warning';
export declare type ValidatorError = [ErrorType, string];
export interface Validators<T> {
    [ruleName: string]: (data: T) => ValidatorError | void;
}
export interface ValidatorGroups {
    pages?: Validators<Page>;
    meta?: Validators<Meta>;
    document?: Validators<Document>;
    layers?: Validators<Layer>;
    artboards?: Validators<Layer>;
    groups?: Validators<Layer>;
}
export declare type Category = keyof ValidatorGroups;
export interface LintingError {
    ruleID: string;
    message: string;
    type: ErrorType;
    path: string;
    category: Category;
}
export {};
