import { LintingError, Validators, Category } from '../types';
interface ValidateItemOptions<I> {
    getCategory(className: string): Category;
    getPath(item: I): string;
}
interface ValidateGroupOptions<I, V> extends ValidateItemOptions<I> {
    getValidators: (item: I) => Validators<V>;
    eachItem?(item: I): LintingError[];
}
export declare function validateItem<I, V>(item: I, validators: Validators<V>, { getPath, getCategory }: ValidateItemOptions<I>): LintingError[];
export default function validateGroup<I, V>(items: I[], { getCategory, getValidators, getPath, eachItem }: ValidateGroupOptions<I, V>): LintingError[];
export {};
