"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function validateItem(item, validators, _a) {
    var getPath = _a.getPath, getCategory = _a.getCategory;
    var errors = [];
    for (var _i = 0, _b = Object.keys(validators); _i < _b.length; _i++) {
        var ruleID = _b[_i];
        var validator = validators[ruleID];
        var category = getCategory(item._class);
        var error = validator(item);
        if (error) {
            errors.push({
                ruleID: ruleID,
                message: error[1],
                type: error[0],
                path: getPath(item),
                category: category,
            });
        }
    }
    return errors;
}
exports.validateItem = validateItem;
function validateGroup(items, _a) {
    var getCategory = _a.getCategory, getValidators = _a.getValidators, getPath = _a.getPath, eachItem = _a.eachItem;
    var errors = [];
    for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
        var item = items_1[_i];
        var validators = getValidators(item);
        if (eachItem) {
            errors = errors.concat(eachItem(item));
        }
        errors = errors.concat(validateItem(item, validators, { getPath: getPath, getCategory: getCategory }));
    }
    return errors;
}
exports.default = validateGroup;
//# sourceMappingURL=validateGroup.js.map