"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var validateGroup_1 = require("./validateGroup");
function validateLayers(layers, classValidators, _a) {
    var getCategory = _a.getCategory, pathPrefix = _a.pathPrefix;
    return validateGroup_1.default(layers, {
        getCategory: getCategory,
        getPath: function (_a) {
            var name = _a.name;
            return pathPrefix + "/" + name;
        },
        getValidators: function (_a) {
            var _class = _a._class;
            return classValidators[_class] || classValidators.default;
        },
        eachItem: function (_a) {
            var childLayers = _a.layers, name = _a.name;
            if (!childLayers) {
                return [];
            }
            return validateLayers(childLayers, classValidators, {
                pathPrefix: pathPrefix + "/" + name,
                getCategory: getCategory,
            });
        },
    });
}
exports.default = validateLayers;
//# sourceMappingURL=validateLayers.js.map